#include <stdafx.h>

#define GetFunctionPointer(M, N, P)                     \
(*(ULONG *) P = (ULONG) GetProcAddress(M, N))

BOOL (__cdecl *NvCplGetThermalSettings) 
	(UINT nWindowsMonitorNumber, DWORD* pdwCoreTemp, DWORD* pdwAmbientTemp, DWORD* pdwUpperLimit);

BOOL NvInitApi()
{
	_TCHAR* szWinDir[MAX_PATH + 1] = {0};
	LPCTSTR pcszNV = "\\system32\\nvcpl.dll";

	GetWindowsDirectory((LPTSTR) szWinDir, sizeof(szWinDir));
	_tcsncat((LPTSTR) szWinDir, pcszNV, MAX_PATH - (_tcslen((LPCTSTR) szWinDir) + _tcslen(pcszNV)));

	HMODULE hDll = LoadLibrary((LPCTSTR) szWinDir);

	if (!hDll)
		return FALSE;

	GetFunctionPointer(hDll, "NvCplGetThermalSettings", &NvCplGetThermalSettings);

	if (!NvCplGetThermalSettings)
		return FALSE;

	return TRUE;

}