#pragma once

#include "resource.h"

#define BMP_DATA_OFFSET 40
#define DIGIT_WITDH 7
#define DIGIT_HEIGHT 16
#define DIGIT_ROW(S, X, N) (((LPBYTE) S) + BMP_DATA_OFFSET + ((DIGIT_WITDH - 1) * X) + (N * 70))
#define GetLeftDigitRow(D, S, X, N) (memcpy(((LPBYTE) D) + N * 8, DIGIT_ROW(S, X, N), 4))
#define GetRightDigitRow(D, S, X, N) (memcpy(((LPBYTE) D) + 4 + (N * 8), DIGIT_ROW(S, X, N), 4))
#define GetDigitRow(D, S, L, R, N) (GetLeftDigitRow(D, S, L, N), GetRightDigitRow(D, S, R, N))

#define WM_TRAYNOTIFY       (WM_APP + 0)

ATOM RegisterWndClass(HINSTANCE hInstance);
extern BOOL InitInstance(HINSTANCE, int);
extern LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

extern LRESULT OnClose(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam);
extern LRESULT OnEndSession(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam);
extern LRESULT OnDestroy(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam);
extern LRESULT OnSize(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam);
extern LRESULT OnTrayNotify(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam);
extern LRESULT OnShowWindow(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam);
extern LRESULT OnPaint(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam);
extern LRESULT OnTimer(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam);
extern LRESULT OnCommand(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam);

extern HICON CreateTrayIcon(HBITMAP hBMPIcon);
extern HBITMAP CreateIconBitmap(HDC hDC, UINT uiValue);
